﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Kompozyt
{
    static class EnumeratorHelper
    {
        public static void ForEach<T>(this IEnumerator<T> enumerator, Action<T> action)
        {
            //enumerator.Reset(); //rozważyć
            while (enumerator.MoveNext())
            {
                action(enumerator.Current);
            }
            enumerator.Reset();
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            Kierownik rektor = new Kierownik("Andrzej", "Sokala", "rektor");
            Kierownik dziekan = new Kierownik("Winicjusz", "Drozdowski", "dziekan");
            Kierownik kierownikKatedry = new Kierownik("Rafał", "Adamczak", "kierownik KIS");
            Pracownik pracownik = new Pracownik("Jacek", "Matulewski", "szary pracownik");
            Pracownik drugiPracownik = new Pracownik("Michał", "Joachimiak", "inny pracownik");

            rektor.DodajPodwładnego(dziekan);
            dziekan.DodajPodwładnego(kierownikKatedry);
            kierownikKatedry.DodajPodwładnego(dziekan);
            kierownikKatedry.DodajPodwładnego(pracownik);
            kierownikKatedry.DodajPodwładnego(drugiPracownik);

            //kierownikKatedry.WyświetlInformacje();
            //kierownikKatedry.Resetuj();
            //kierownikKatedry.WyświetlInformacje();

            //kierownikKatedry.PrzyjmijWizytę(new OdwiedzającyWyświetlającyInformacje());
            rektor.PrzyjmijWizytę(new OdwiedzającyWyświetlającyInformacje());

            OdwiedzającyLiczący odwiedzającyLiczący = new OdwiedzającyLiczący();
            rektor.PrzyjmijWizytę(odwiedzającyLiczący);
            odwiedzającyLiczący.ZwróćLiczbęOdwiedzin();

            OdwiedzającySpłaszczający odwiedzającySpłaszczający = new OdwiedzającySpłaszczający();
            rektor.PrzyjmijWizytę(odwiedzającySpłaszczający);
            var a = odwiedzającySpłaszczający.Pracownicy;

            IEnumerable<string> zapytanie = from IPracownik p in rektor
                                            select p.ToString();
            string[] b = zapytanie.ToArray();
            int liczbaPracowników = rektor.Count();

            //!!!!zanim zdefiniujesz iterator, przećwicz go na liście - odtwórz pętlę foreach

            Console.WriteLine("********************");
            List<int> listaInt = new List<int>(5) { -1, 0, 1, 2, 3, 4 };
            //List<int>.Enumerator enumerator = listaInt.GetEnumerator();
            IEnumerator<int> enumerator = listaInt.GetEnumerator();

            //foreach
            while (enumerator.MoveNext())
            {
                Console.WriteLine("Element: " + enumerator.Current);
            }
            enumerator.Reset();

            while (enumerator.MoveNext())
            {
                Console.WriteLine("Element: " + enumerator.Current);
            }
            enumerator.Reset();

            enumerator.ForEach((int i) => { Console.WriteLine("Element: " + i); });

            int n = 0;
            double średnia = 0;            
            enumerator.ForEach((int i) => { n++; średnia += i; });
            średnia /= n;
            Console.WriteLine("Średnia: " + średnia);
        }
    }
}
